"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("../index");
var fs_1 = __importDefault(require("fs"));
// 生成 .debug/index.ts 文件
function generateDebugEntry() {
    var isSimple = index_1.isSimpleTemplate();
    // 查看config.json是否存在 customSetter
    var configPath = './src/config.json';
    var configContent = fs_1.default.readFileSync(configPath, 'utf-8');
    var config = {};
    try {
        config = JSON.parse(configContent);
    }
    catch (error) { }
    var isCustomUpgradeExist = false;
    try {
        fs_1.default.accessSync('./src/upgrade.ts');
        isCustomUpgradeExist = true;
    }
    catch (error) { }
    // config.json里没有参数也返回 ''
    if (isSimple || isCustomUpgradeExist || !config.isUpgrade) {
        return '';
    }
    return "\nexport interface UpgradeContext {\n  schema: any;\n  data?: any;\n}\n\nexport type IScene = 'designer' | 'create' | 'detail'\n\nexport default (scene: IScene, preContext: UpgradeContext, currContext: UpgradeContext) => {\n  switch(scene) {\n    case 'designer':\n      return processDesignerContext(preContext, currContext);\n    case 'create':\n      return processCreateContext(preContext, currContext);\n    case 'detail':\n      return processDetailContext(preContext, currContext);\n  }\n}\n\nfunction processDesignerContext(preContext: UpgradeContext, currContext: UpgradeContext) {\n  return null;\n}\n\nfunction processCreateContext(preContext: UpgradeContext, currContext: UpgradeContext) {\n  return null;\n}\n\nfunction processDetailContext(preContext: UpgradeContext, currContext: UpgradeContext) {\n  return null;\n}\n  ";
}
exports.default = generateDebugEntry;
