"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var isArray_1 = __importDefault(require("lodash/isArray"));
var filter_1 = __importDefault(require("lodash/filter"));
// 生成 .debug/index.ts 文件
function generateBuild() {
    // 查看config.json是否存在 customSetter
    var configPath = './src/config.json';
    var configContent = fs_1.default.readFileSync(configPath, 'utf-8');
    var isCustomSetterExist = false;
    var isCustomUpgradeExist = false;
    var setterName = '';
    try {
        var config = JSON.parse(configContent);
        var setters = config.setters, bizType = config.bizType, isUpgrade = config.isUpgrade, props = config.props;
        setterName = bizType.replace(/[^a-zA-Z0-9]/gi, "") + "Setter";
        if (isArray_1.default(setters) && setters.length > 0) {
            // 找出所有自定义setter
            var customSetter = filter_1.default(setters, function (item) { var _a; return ((_a = item) === null || _a === void 0 ? void 0 : _a.type) === 'custom'; });
            if (isArray_1.default(customSetter) && customSetter.length > 0) {
                isCustomSetterExist = true;
            }
        }
        if (isUpgrade === true && props && props.version) {
            isCustomUpgradeExist = true;
        }
    }
    catch (error) { }
    return "\n  {\n    \"plugins\": [\n      \"build-plugin-component\",\n      [\n        \"build-plugin-stark-module\",\n        {\n          \"moduleExternals\": {\n            \"react\": \"React\",\n            \"react-dom\": \"ReactDOM\",\n            \"antd\": \"antd\",\n            \"antd-mobile\": \"AntdMobile\"\n          },\n          \"modules\": {\n            \"pc\": \".debug/runtime/pc.tsx\",\n            \"mobile\": \".debug/runtime/mobile.tsx\",\n            " + (!isCustomSetterExist
        ?
            ''
        :
            '"setter": ".debug/designer/setter/CustomSetter/index.tsx",') + "\n            " + (!isCustomUpgradeExist
        ?
            ''
        :
            '"upgrade": ".debug/src/upgrade.ts",') + "\n            \"config\": \".debug/config.ts\"\n          }\n        }\n      ]\n    ]\n  }";
}
exports.default = generateBuild;
