"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var cross_spawn_1 = __importDefault(require("cross-spawn"));
var path_1 = __importDefault(require("path"));
var constants_1 = require("../constants");
var webpack = require('webpack');
var WebpackDevServer = require('webpack-dev-server');
var webpackConfig = require('./../webpack/dev');
function runInstall(name) {
    return __awaiter(this, void 0, void 0, function () {
        var root, rootEditor, rootRender;
        return __generator(this, function (_a) {
            root = path_1.default.resolve(name);
            rootEditor = path_1.default.resolve(root, constants_1.TEMPLATE_PACKAGE_EDITOR);
            rootRender = path_1.default.resolve(root, constants_1.TEMPLATE_PACKAGE_RENDER);
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    try {
                        cross_spawn_1.default.sync('tnpm', ['install'], { cwd: root });
                        cross_spawn_1.default.sync('tnpm', ['install'], { cwd: rootEditor });
                        cross_spawn_1.default.sync('tnpm', ['install'], { cwd: rootRender });
                        resolve();
                    }
                    catch (error) {
                        reject(error);
                    }
                })];
        });
    });
}
exports.runInstall = runInstall;
function runStart(config) {
    return __awaiter(this, void 0, void 0, function () {
        var entry, plugins, webpackConfig2, compiler, devServer, port, host;
        return __generator(this, function (_a) {
            entry = config.entry, plugins = config.plugins;
            webpackConfig2 = __assign(__assign({}, webpackConfig), { entry: entry, plugins: webpackConfig.plugins.concat(plugins) });
            compiler = webpack(webpackConfig2);
            devServer = webpackConfig.devServer;
            port = devServer.port, host = devServer.host;
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    try {
                        var server = new WebpackDevServer(compiler, __assign({}, devServer));
                        server.listen(port, host, function (err) {
                            if (err) {
                                reject(err);
                            }
                            resolve();
                        });
                    }
                    catch (err) {
                        reject(err);
                    }
                })];
        });
    });
}
exports.runStart = runStart;
