var webpack = require('webpack');
var path = require('path');
var merge = require('webpack-merge').merge;
var baseConfig = require('./base');
var mode = 'development';
var entry = {};
var alias = {
    '@': path.join(process.cwd(), './'),
};
var devtool = 'cheap-module-eval-source-map';
var plugins = [new webpack.HotModuleReplacementPlugin()];
var devServer = {
    contentBase: './',
    publicPath: '/',
    disableHostCheck: true,
    hot: true,
    open: false,
    host: '127.0.0.1',
    compress: true,
    port: 3001,
    headers: {
        'Access-Control-Allow-Origin': '*',
    },
};
module.exports = merge(baseConfig, {
    mode: mode,
    entry: entry,
    resolve: {
        alias: alias,
    },
    plugins: plugins,
    devtool: devtool,
    devServer: devServer,
});
